package com.pl.flutterpluginwx.handlers

import android.content.Context
import com.tencent.mm.opensdk.openapi.IWXAPI
import com.tencent.mm.opensdk.openapi.WXAPIFactory
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel

object WXAPiHandler {

    var wxApi: IWXAPI? = null

    private var context: Context? = null

    fun setContext(context: Context?) {
        WXAPiHandler.context = context
    }

    fun registerApp(call: MethodCall, result: MethodChannel.Result) {

        if (call.argument<Boolean?>("android") == false) {
            return
        }

        if (wxApi != null) {
            result.success(true)
            return
        }

        val appId: String? = call.argument("appId")
        if (appId.isNullOrBlank()) {
            result.error("invalid app id", "are you sure your app id is correct ?", appId)
            return
        }

        val api = WXAPIFactory.createWXAPI(context?.applicationContext, appId)
        val registered = api.registerApp(appId)
        wxApi = api
        result.success(registered)
    }

    fun checkWeChatInstallation(result: MethodChannel.Result) {
        if (wxApi == null) {
            result.error("Unassigned WxApi", "please config  wxapi first", null)
            return
        } else {
            result.success(wxApi?.isWXAppInstalled)
        }

    }
}